#function to assign labels for data generated by SurveyEngine.

ass_labels <- function(path, seelab=TRUE, lower=FALSE) {

  labels <- read_excel(path = path, sheet = "dictionary", col_names = TRUE)[-2:-1,2:4]  %>% rename( "Variable"=1 ,   "Labels"=2   ,   "valuelabels"=3)


  if (lower==TRUE) labels$Variable <- tolower(labels$Variable)


  covdata <- read_excel(path = path)


  ## check if variables are all present
  #test 1

  cat("Number of variables in dataset: ",length(names(covdata)) ,
      "\n Number of variables in label set:", length(labels$Variable[!is.na(labels$Variable)]), "\n")

  if (length(names(covdata)) != length(labels$Variable[!is.na(labels$Variable)]) ){
    cat("\n labels do not match, will be ignored, but make sure this is ok.
           \n Below are the variables that are problematic. \n \n These variables exist in the dataset but not in the label set:",
        setdiff(names(covdata) , labels$Variable[!is.na(labels$Variable)]) ,
        "\n and these exist in the labels and not in the dataset:" ,
        setdiff(labels$Variable[!is.na(labels$Variable)], names(covdata)))
  }

  for (vn in names(covdata)) {
    attr(covdata[[vn]], "label") <- toString(labels[which(labels$Variable==vn),"Labels"])
  }


  labels$Variable <- na.locf(labels$Variable)
  labels <- labels[!is.na(labels$Labels),]

  X <- base::split(labels, labels$Variable)

  Y=lapply(X, row_to_names , row_number = 1)


  for (vn in names(covdata)) {

    if (is.null(attr(covdata[[vn]], "class")) == TRUE) {
      attr(covdata[[vn]], "class") <- "haven_labelled"
    }


    if (exists(vn,Y)==TRUE && nrow(Y[[vn]])>1 ) {

      if(seelab==TRUE) cat("\n the variable", vn , " will be labelled \n" )

      t <- as.numeric(unlist(Y[[vn]][2]))
      names(t) <- unlist(Y[[vn]][3])
      attr(covdata[[vn]] , "labels") <- t
    }
    else{ if(seelab==TRUE) cat("\n Attention: the values of the variable", vn , " will NOT be labelled \n" )}

  }

  return(covdata)

}
